using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ScriptCallbacks.BusinessObjects;
using Westwind.Tools;
using System.Globalization;

public partial class Anthem_Chat : System.Web.UI.Page
{
    DateTime LastOn = DateTime.Now.AddMinutes(-5);
    busChatMessage Message = new busChatMessage();
      
    protected void Page_Load(object sender, EventArgs e)
    {
        object TVal = ViewState["Chat_LastOn"];
        if (TVal != null)
            this.LastOn = (DateTime)TVal;
        //else
        //    // *** First access - force immediate message display
        //    this.WriteNewMessages();
    }

    protected void btnSend_Click(object sender, EventArgs e)
    {
        if (this.txtMessage.Text == "")
        {
            // *** Trigger to clear old messages - keeps db size in check
            Message.ClearMessages();  
            return;
        }

        Message.New();
        Message.Entity.Message = wwUtils.ExpandUrls(wwUtils.DisplayMemoEncoded(this.txtMessage.Text));
        Message.Entity.Sender = this.txtName.Text;
        Message.Entity.Chatid = this.txtChatId.Text;
        Message.Entity.Time = DateTime.Now;
        Message.Save();

        this.txtMessage.Text = "";
        this.txtMessage.UpdateAfterCallBack = true;
    }

    protected void btnRefresh_Click(object sender, EventArgs e)
    {
        this.WriteNewMessages();
    }


    /// <summary>
    /// Writes any new messages into the message display in lblMessages
    /// Adds to existing messages
    /// </summary>
    protected void WriteNewMessages()
    {
        string MessagesHtml = Message.GetMessagesHtml(this.LastOn, this.txtChatId.Text);
        if (MessagesHtml == null)
            return;

        // *** Update Last on time stamp for user
        ViewState["Chat_LastOn"] = DateTime.Now;

        // *** No new messages - Don't update anything!
        if (MessagesHtml == "")
            return;

        this.lblMessages.Text = this.lblMessages.Text + MessagesHtml;
        //this.lblMessages.Text = this.MessageText.Value + MessagesHtml;
        
        if (this.lblMessages.Text.Length > 20000)
            this.lblMessages.Text = this.lblMessages.Text.Substring(5000);

        this.lblMessages.UpdateAfterCallBack = true;
    }


    protected void MessageTimer_Tick(object sender, EventArgs e)
    {
        this.WriteNewMessages();
    }


    /// <summary>
    /// This is an alternate method that ships only the most recent messages
    /// back to the client. This method is much more efficient and allows you
    /// to turn off ViewState on the lblMessage Control. But it requires
    /// more code here and on the client to make this happen.
    /// </summary>
    /// <param name="ChatId"></param>
    /// <param name="LastOn"></param>
    /// <returns></returns>
    [Anthem.Method]
    public string RefreshMessages(string ChatId, string LastOn)
    {
        // *** IE returns UTC - Mozilla returns GMT
        LastOn = LastOn.Replace("UTC", "GMT");

        string[] fmt = {"r","R","ddd, dd MMM yyyy HH:mm:ss"}; 
        DateTime Time;

        if (!DateTime.TryParseExact(LastOn, fmt, CultureInfo.InvariantCulture, DateTimeStyles.AssumeUniversal, out Time))
            return " ";

        string MessagesHtml = Message.GetMessagesHtml(Time, this.txtChatId.Text);
        return MessagesHtml;
    }
}
