﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="CustomerListJSON.aspx.cs" Inherits="CustomerListJSON"
    EnableEventValidation="false" %>

<%@ Register Src="../ShowCode.ascx" TagName="ShowCode" TagPrefix="uc1" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Northwind Customer List</title>
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
    <link href="../csharp.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="form1" runat="server">

        <script type="text/javascript">
var CustRow = null;

function GetCustomerListCallback(Result) 
{
    // *** Returns a 'DataTable' object
    var Table = Result.value;
    
    // *** Get a reference to the list for easier access
    var List = document.getElementById('lstCustomers');
    
    if (List == null)
        return;
    
    var SelectedIndex = List.selectedIndex;
    
    // *** Clear the list first
    for (x=List.options.length-1; x > -1; x--) 
    {
        List.remove(0);
    }

    // *** Now loop through rows and assign to list            
    for (x=0; x < Table.Rows.length; x++ )
    {
        var Row = Table.Rows[x];  // Mozilla needs to assign
        
        var option = document.createElement("option");
		option.text = Row.CompanyName;
		option.value = Row.CustomerId;

		if ( window.navigator.appName.toLowerCase().indexOf("microsoft") > -1) 
		    List.add(option);  
		else
		    List.add(option, null); 
     }
    
    // *** Show First Item
    if (List.length > 0) 
    {
        if (SelectedIndex < 0)
            SelectedIndex = 0;
            
        List.selectedIndex = SelectedIndex;
        List.onchange();
    }
}
function GetCustomerRowCallback(Result) 
{
    // *** Return a DataRow from the Server
    CustRow = Result.value;

    // *** NOTE: You can also return entity objects in the same way
    
    AssignValue( "txtContactName",CustRow.ContactName);
    AssignValue( "txtCompany",CustRow.CompanyName);
    AssignValue( "txtAddress",CustRow.Address);
    AssignValue( "txtCity",CustRow.City);
    AssignValue( "txtCountry",CustRow.Country);
    AssignValue( "txtRegion",CustRow.Region);
    AssignValue( "txtPostalCode",CustRow.PostalCode);
    
    var TitleSpan = document.getElementById("DialogTitle");
    if (TitleSpan) 
        TitleSpan.innerHTML = CustRow.CompanyName;
}
function AssignValue(ControlName,Value)
{
    if (Value == null)
        Value = "";
        
    var Ctl = document.getElementById(ControlName);
    if (Ctl)
        Ctl.value = Value;
}
function SaveCustomerCallback(Result)
{
    if (Result.error)
    {
        alert(Result.error);
        return;
    }
    if (Result.value == null)
        return;
         
    if (Result.value) 
    {
       // Force list to refresh - realistically
       // we should update only the one listitem
       Anthem_InvokePageMethod('GetCustomerList',[],GetCustomerListCallback);
       alert("Customer Saved!");
    }
    else
       alert(Result.value.error);
}
        </script>

        <div>
            <h1>    
                Anthem JSON Northwind Customer List</h1>
        </div>
        <a href="../default.aspx">Home</a> | <asp:LinkButton runat="server" ID="lnkReset">Reset</asp:LinkButton> | <small>Page generated at: <%= DateTime.Now %></small><br />
        <br />
        <br />
        <center>
            &nbsp;<table class="blackborder" style="background: #eeeeee; text-align: left; height: 459px;"
                cellpadding="0">
                <tr class="gridheader">
                    <td colspan="2" cssclass="gridheader" height="24">
                        &nbsp;<span id="DialogTitle">Customer List</span></td>
                </tr>
                <tr>
                    <td valign="top" style="height: 435px">
                        <asp:ListBox ID="lstCustomers" runat="server" Height="442px" Width="300px" 
                                     onchange="Anthem_InvokePageMethod('GetCustomerRow',[this.value],GetCustomerRowCallback);">
                        </asp:ListBox>
                        </td>
                    <td valign="top" style="padding-left: 20px; padding-top: 10px; padding-right: 10px;
                        height: 435px;">
                        <asp:Label ID="Label2" runat="server" Text="Name:" Width="263px"></asp:Label><br />
                        <asp:TextBox ID="txtContactName" runat="server" Width="350px"></asp:TextBox><br />
                        <br />
                        <asp:Label ID="Label1" runat="server" Text="Company:"></asp:Label><br />
                        <asp:TextBox ID="txtCompany" runat="server" Width="350px"></asp:TextBox><br />
                        <br />
                        Address:<br />
                        <asp:TextBox ID="txtAddress" runat="server" Width="350px" Height="53px" TextMode="MultiLine"></asp:TextBox><br />
                        <br />
                        City:<br />
                        <asp:TextBox ID="txtCity" runat="server" Width="350px"></asp:TextBox><br />
                        <br />
                        <table>
                            <tr>
                                <td>
                                    Region:
                                    <br />
                                    <asp:TextBox ID="txtRegion" runat="server" Width="74px"></asp:TextBox></td>
                                <td>
                                    &nbsp;&nbsp;Postal Code:<br />
                                    &nbsp;&nbsp;<asp:TextBox ID="txtPostalCode" runat="server" Width="192px"></asp:TextBox><br />
                                </td>
                            </tr>
                        </table>
                        <br />
                        Country:<br />
                        <asp:TextBox ID="txtCountry" runat="server" Width="350px" /><br />
                        <hr />
                        &nbsp;
                        <input type="button" value=" Save Customer " accesskey="S"
                               onclick="Anthem_InvokePageMethod('SaveCustomer',[],SaveCustomerCallback);"
                               style="width: 150px" size="" />
                        <input type="button" value="Refresh List " 
                               onclick="Anthem_InvokePageMethod('GetCustomerList',[],GetCustomerListCallback);"
                               style="width: 150px" size="" />
                               </td>
                </tr>
            </table>
        </center>

        <script type="text/javascript">
        //Callback.GetCustomerList(GetCustomerListCallback);
        Anthem_InvokePageMethod('GetCustomerList',[],GetCustomerListCallback);                        
        </script>

        <p />
        <blockquote>
            This example uses a slightly modded version of the Ajax .NET Library from Jason
            Diamond. This library allows using attributed methods on the current page to be
            fired from the client. The Ajax library generates matching client side methods for
            the server side methods and supports marshalling of some complex types like DataTables,
            DataRows and Arrays. This example, downloads the customer list when the form starts,
            then allows selection of individual items. The list is downloaded as a DataTable,
            each Customer is downloaded via DataRow. Data is saved by reading the form's fields
            just like a standard page POSTBack (watch out for list objects though).
        </blockquote>
        <hr />
        <uc1:ShowCode ID="ShowCode1" runat="server" CodeFile="~/Anthem/CustomerListJSON.aspx.cs"
            Text="Show Code" />
        <uc1:ShowCode ID="ShowCode2" runat="server" CodeFile="~/Anthem/CustomerListJSON.aspx"
            Text="Show ASPX" />
    </form>
</body>
</html>
