using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using ScriptCallbacks.BusinessObjects;
using Anthem;

public partial class CustomerListJSON: System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
       Anthem.Manager.Register(this);
    }

    [Anthem.Method]
    public DataTable GetCustomerList()
    {
        busCustomer Customer = new busCustomer();
        if (Customer.GetCustomerList() < 0)
            return null;

        return Customer.DataSet.Tables["TCustomerList"];
    }

    [Anthem.Method]
    public DataRow GetCustomerRow(string CustomerId)
    {
        busCustomer Customer = new busCustomer();
        if (!Customer.Load(CustomerId))
            return null;

        return Customer.DataRow;
    }

    [Anthem.Method]
    public ScriptCallbacks.BusinessObjects.CustomersRow GetCustomerEntity(string CustomerId)
    {
        busCustomer Customer = new busCustomer();
        if (!Customer.Load(CustomerId))
            return null;

        return Customer.Entity;
    }

    /// <summary>
    /// Demonstrates using POSTback form vars
    /// </summary>
    /// <param name="CustomerId"></param>
    /// <returns></returns>
    [Anthem.Method]
    public bool SaveCustomer()
    {
     string x = this.lstCustomers.SelectedValue;
        string CustomerId = Request.Form["lstCustomers"];

        busCustomer Customer = new busCustomer();

        if (CustomerId == null)
            throw new ApplicationException("Invalid CustomerId");
        
        if (CustomerId == "")
        {
            if (!Customer.New())
                throw new ApplicationException("Couldn't create new customer.");
            ;
        }
        else
        {
            if (!Customer.Load(CustomerId))
                throw new ApplicationException("Couldn't load customer");
        }

        // *** Pick up values that were posted back from the
        // *** the client callback
        Customer.Entity.Contactname = this.txtContactName.Text;
        Customer.Entity.Companyname = this.txtCompany.Text;
        Customer.Entity.Address = this.txtAddress.Text;
        Customer.Entity.City = this.txtCity.Text;

        if (!Customer.Validate())
            throw new ApplicationException(Customer.ValidationErrors.ToString());
  
        if (!Customer.Save())
            throw new ApplicationException(Customer.ErrorMessage);

        return true;
    }
}
