using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Westwind.BusinessObjects;

namespace ScriptCallbacks.BusinessObjects
{

    /// <summary>
    /// Summary description for busQueueMessge
    /// </summary>
    public class busQueueMessage : wwBusiness<QueuemessagesRow>
    {
        
        /// <summary>
        /// Message Timeout in hours. Messages are cleared
        /// with ClearMessages()
        /// </summary>
        public int MessageTimeout
        {
            get { return _MessageTimeout; }
            set { _MessageTimeout = value; }
        }
        private int _MessageTimeout = 2;


        public busQueueMessage()
        {
            this.ConnectionString = App.Configuration.ApplicationConnectionString;
            this.ConnectType = ServerTypes.SqlServer;
            this.DataRowUpdateMode = DataRowUpdateModes.OptimizedByPk;
            this.NewRowBlankValues = true;
            this.Tablename = "QueueMessages";
            this.PkField = "ReqId";
            this.PkType = PkFieldTypes.stringType;
        }

        public override bool New()
        {
            if (!base.New())
                return false;

            this.Entity.Started = DateTime.UtcNow;
            return true;
        }


        /// <summary>
        /// Sets the Entity record with the required settings
        /// to complete a request. Note record is not written
        /// to database - Call Save explicitly.
        /// </summary>
        public void CompleteRequest()
        {
            this.Entity.Percentcomplete = 100;
            this.Entity.Status = "Completed";
            this.Entity.Completed = DateTime.UtcNow;
            this.Entity.Complete = true;
        }
       
        /// <summary>
        /// Sets the Entity record with the required settings
        /// to complete and cancel a request. Not saved to database
        /// call Save() explicitly.
        /// </summary>
        public void CancelRequest()
        {
            this.Entity.Status = "Cancelled";
            this.Entity.Completed = DateTime.UtcNow;
            this.Entity.Complete = true;
            this.Entity.Cancelled = true;
        }

        /// <summary>
        /// Method used to clear out 'old' messages to keep database size down
        /// </summary>
        public void ClearMessages()
        {
            this.ExecuteNonQuery("delete from " + this.Tablename + " where Started<@Started and Started > '01/01/2000' ",
                                 this.CreateParameter("@Started", DateTime.UtcNow.AddDays(this.MessageTimeout * -1)));
        }
    }

    public enum QueueMessageStatus
    {
        Started,
        Completed,
        InProcess,
        Cancelled
    }
}