<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Chat.aspx.cs" Inherits="Atlas_Chat"
         EnableViewState="true" EnableEventValidation="false" ValidateRequest="false" %>

<%@ Register Src="../ShowCode.ascx" TagName="ShowCode" TagPrefix="uc1" %>

<%@ Register Assembly="Anthem" Namespace="Anthem" TagPrefix="anthem" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>ATLAS Chat</title>
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
    <style>
    TD { font-size: 8pt; font-face: Tahoma sans-serif; }
    INPUT { font-size: 8pt; font-face: Tahoma sans-serif; }
    .ChatList { font-size:8pt; font-face: Tahoma; border: 1px solid Darkblue; background:white; }
    </style>
</head>
<body  >
     <atlas:ScriptManager ID="ScriptManager1" runat="server" EnableScriptComponents="true" EnablePartialRendering="true">
        <Services>
            <atlas:ServiceReference Path="~/Atlas/ChatService.asmx"  />
        </Services>
    </atlas:ScriptManager>
    <form id="ChatForm" runat="server">
        <div>
            <h1>ATLAS Chat</h1>
            <a href="../default.aspx">Home</a> | <asp:LinkButton runat="server" ID="lnkRefresh">Reset Page</asp:LinkButton> | <a href="chat.aspx" target="_blank">
                Open another Window</a> | <small>Page
                created:&nbsp;<%= DateTime.Now.ToString() %></small><br />
            &nbsp;<br />
                <blockquote>
                <div id="lblErrorMessage" class="errordisplay" 
                     style="width:400px;display:none;padding:8px;padding-left: 20px;">
                </div>
                
                <table class="blackborder" cellpadding="10" width="650"
                       style="background: #b5c7d6;">
                <tr>
                <td valign="top">
                    Messages:
                    <div id="divMessages" style="padding:5px;background:cornsilk;overflow-Y:scroll;border:solid 1px teal;height:250px;width:450px">
                    <asp:Label ID="lblMessages" runat="server" Height="152px" Width="440px"></asp:Label></div>                                  
                    <hr />
                    <table>
                    <tr>
                    <td valign="top" style="width: 402px; height: 31px;">
                     Enter a Message:<br />
                    <asp:TextBox ID="txtMessage" runat="server" Height="50px" TextMode="MultiLine"
                        Width="360px"  Font-Size="8pt" Font-Names="tahoma,sans serif"></asp:TextBox>
                    </td>
                    <td style="width: 100px; height: 31px">
                    <!-- input type="button" ID="btnRefresh" style="height:30px;width:90px;" value="Refresh" AccessKey="R" onclick="GetActiveUsers()" -->
                    <input type="button" ID="btnSend" style="height:50px;width:90px;" Value="Send" AccessKey="S" onclick="WriteMessage()">
                    </td>
                    </tr>
                    </table>
                    </td>
                 <td valign="top" style="border-left:solid 1px blue;background:cornsilk;width:165px;">
                    Your Handle:<br />
                    <asp:TextBox ID="txtName" runat="server" Width="100px" Font-Size="8pt"></asp:TextBox>
                    <br /><br />
                    <div class="gridalternate" style="padding: 5px;border:solid 1px darkblue;">
                    Enter a Chat Id:<br />
                    <asp:TextBox ID="txtChatId" runat="server" Width="100px"  Font-Size="8pt">TestChat</asp:TextBox><input type="button" id="btnChatList" value="..." onclick="PopupChatList();" style="font-size:8pt;height:20px;width:20px" />
                    <p />
                    Active Users:
                    <div id="divUserList" style="height:230px;overflow-Y:auto;background:white;padding:5px;">     
                    </div>                  

                    </div>
                 </td>
                </tr>
                </table>   

                
                      
    <div id="divChatList" class="ChatList" 
         style="position:absolute;height:30px;border:solid 1px Darkblue;padding:5px;display:none;background:white;">
    </div>
    <p />
    <hr />
    <small>
    This example demonstrates using ATLAS and its JSON Web Service functionality along with JavaScript code to create a
    Chat application. This sample uses plain
        JavaScript for updating the display and managing the various user interface features.
    </small>        
 
              
    </blockquote>
            <blockquote>
                <small>
    Since AJAX cannot reliably do a PUSH model the only way for the client to get the latest messages is to poll the server for updates frequently. Therefore 
    this is a very chatty interface that fires a lot of requests to the server. Load with many users in this scenario
    could very easily become a scalability problem. However,
                    this example uses pure JSON messages which push only updated data back and forth
                    so message size generally is very small. You might want to break out Fiddler and
                    compare both the ATLAS and Anthem chat which use different approaches, where this
                    approach is the more bandwidth friendly of the two.</small>
    <hr />
            </blockquote>
    <atlas:UpdatePanel runat="server" ID="CodeUpdatePanel" Mode="Conditional">
    <ContentTemplate>
    <uc1:ShowCode ID="ShowCode1" runat="server" CodeFile="~/Atlas/Chat.aspx" Text="ASPX" width="100"/>
    <uc1:ShowCode ID="ShowCode2" runat="server" CodeFile="~/Atlas/Chat.aspx.cs" Text="CodeBehind" width="100" />
    <uc1:ShowCode ID="ShowCode3" runat="server" CodeFile="~/Atlas/ChatService.asmx" Text="Service" width="100"/>
    </ContentTemplate>
    </atlas:UpdatePanel>            
    </div>
    <script type="text/javascript">   
var IsMSIE = navigator.userAgent.indexOf('MSIE') > -1 ? true : false;
    
function WriteMessage()
{
    var Name = $('txtName').value;
    if (Name == "")
    {
        ShowError("Please enter your name or handle.");
        $('txtName').focus();
        return;
    }
    
    $('btnSend').disabled = true;
    ChatService.WriteMessage($('txtMessage').value,Name,$('txtChatId').value,OnWriteCallback)
}
function OnWriteCallback(Result)
{
    $('btnSend').disabled = false;
    
    var Ctl = $('txtMessage');
    Ctl.value = '';
    Ctl.focus();
}
function GetMessages()
{
    ChatService.GetMessages($('txtChatId').value,$('txtName').value,GetMessagesCallback);
}
function GetMessagesCallback(Result)
{        
    if (Result == null || Result == "")
        return;
    
    var Ctl = $('lblMessages');
    
    var Message = Ctl.innerHTML;
    
    Ctl.innerHTML = Ctl.innerHTML + Result;        
    
    $('divMessages').scrollTop = 999999; 
}
function GetActiveUsers()
{
    ChatService.GetActiveUsers($('txtChatId').value,GetActiveUsersCallback);
}
function GetActiveUsersCallback(Result)
{
    $('divUserList').innerHTML = Result;
}
function PopupChatList()
{
     ChatService.GetChatListHtml(GetChatListCallback);   
}
function GetChatListCallback(Result)
{
    var Ctl = $('divChatList');
    Ctl.innerHTML = Result + 
                    "<hr /><div style='text-align:right'><a href='javascript:SetChatId()'>Close</a></div>";
    Ctl.style.display='';
    
    var Btn = $('txtChatId');
    Btn.style.position='absolute';
    Ctl.style.top = Btn.offsetTop + Btn.offsetHeight + "px";
    Ctl.style.left = Btn.offsetLeft + "px";
    Ctl.style.width = Btn.offsetWidth  - 12 +"px"
    Ctl.style.zIndex = 99;
    Btn.style.position = '';
    
    ShowShadow(Ctl.id,.50,3);
}
function SetChatId(ChatId)
{
    if (ChatId != null)
        $('txtChatId').value = ChatId;

    HideShadowControl('divChatList',false);            
    
    GetActiveUsers();
    
    var Ctl = $('lblMessages');
    Ctl.innerHTML = '';
}
function OnError(Result)
{
   ShowError("An error occurred: "  + Result.get_message());
}
function ShowError(Message,ShowInfoMessage)
{
    var Ctl = $('lblErrorMessage');
    if (ShowInfoMessage)
        Ctl.innerHTML = " <img src='../images/info.gif'> " + Message;
    else
        Ctl.innerHTML = " <img src='../images/warning.gif'>  &nbsp;&nbsp;" + Message;
    Ctl.style.display = '';
    
    Ctl.style.position = 'absolute';
    ShowShadow("lblErrorMessage",.30,4);
    
    window.setTimeout("HideError()",5000);
}
function HideError()
{
    HideShadowControl('lblErrorMessage');
}

function ShowShadow(CtlId,Opacity,Offset)
{
   var Ctl = $(CtlId);
   if (Ctl == null)
      return;

   var OldWidth = Ctl.style.width;
   var OldHeight = Ctl.style.height;
      
   if (Opacity == null)
      Opacity = ".40";
   if (Offset == null)
      Offset = 8;
   
   var Shadow = $(CtlId + 'Shadow');
   if (Shadow == null)
   {
       Shadow = document.createElement('div');
       Shadow.id = CtlId + 'Shadow';
       Ctl.parentNode.appendChild(Shadow);
       Shadow.style.position='absolute';
       Shadow.style.background = 'black';
       if (IsMSIE)
           Shadow.style.filter = "alpha(opacity='" + Opacity * 100 + "')";
       else
           Shadow.style.opacity = Opacity;

       Ctl.style.zIndex = 99;
       Shadow.style.zIndex = 98;
   }
   
   Shadow.style.display = '';
   Shadow.style.top = Ctl.offsetTop + Offset + "px";
   Shadow.style.left = Ctl.offsetLeft + Offset + "px";
   Shadow.style.width = Ctl.offsetWidth +"px";
   Shadow.style.height = Ctl.offsetHeight  + "px";
   
   Ctl.style.width = OldWidth;
   Ctl.style.height = OldHeight;
}
function HideShadowControl(CtlId,HideShadowOnly)
{
    var Ctl = $(CtlId);
    if (HideShadowOnly == null || HideShadowOnly == false)
    {
        if (Ctl == null)
            return;
        Ctl.style.display = 'none';
    }
    
    Ctl = $(CtlId + "Shadow");
    if (Ctl == null)
       return;
    Ctl.style.display = 'none';
}

// *** Manually fire the 'Refresh' rather than using a Timer Object
// *** because we need a Pre event to pick up the Message Text
window.setInterval("GetMessages()",5100);    
window.setInterval("GetActiveUsers()",30000);
window.setTimeout("GetActiveUsers();",1500);
    </script>    

    </form>
</body>
</html>
