<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head id="Head1" runat="server">
    <title>ASP.NET &quot;Atlas&quot; Control Sample</title>
    <link href="intro.css" type="text/css" rel="Stylesheet" />
</head>

<body>
    <form id="form1" runat="server">
        <div>
            <atlas:ScriptManager runat="server" ID="ScriptManager1" />
            <div id="content" class="title">
                <h2>ASP.NET &quot;Atlas&quot; Demo: Sys.Control</h2>
                This page contains JavaScript that simply demonstrates the use of ASP.NET &quot;Atlas&quot;
                controls and their OM. The ASP.NET &quot;Atlas&quot; controls are associated to markup elements
                and are used to programmatically set properties, and attach to and listen to events.
            </div>
            <hr />
            <div class="description">
                <h3><u>Example 1:</u></h3>
                <div id="panel">
                    This panel (div element) will be affected by color selection and clicking the cursor button.
                </div>
                <br />
                Select a color for the panel:&nbsp;<select id="colorSelect" class="itemselect">
                    <option value="normal">Normal</option>
                    <option value="red">Red</option>
                    <option value="blue">Blue</option>
                    <option value="notset">NotSet</option>
                </select>
                &nbsp;&nbsp;
                <input type="button" id="cursorButton" class="buttonstyle"
                    value="Set the hover cursor for the panel (IE specific)" />
                &nbsp;<span id="cursorLabel"></span>

                <hr />
                <h3><u>Example 2:</u></h3>
                <input id="textBox" type="text"/>
                &nbsp;&nbsp;
                <input type="button" id="visibilityButton"  class="buttonstyle"
                    value="Toggle Visibility Property" />
                &nbsp;&nbsp;
                <input type="button" id="enabledButton" class="buttonstyle"
                    value="Toggle Enabled Property" />
                
                <hr />
            </div>

            <script type="text/javascript">
            
                // The script is placed at the end here so that the elements will 
                // be located
                var g_panel;
                var g_selColor;
                var g_label;
                        
                function pageLoad()
                {
                    // Set up the atlas panel and set up the initial css
                    g_panel = new Sys.UI.Control($('panel'));
                    g_panel.initialize();
                    g_panel.set_cssClass('normal');

                    // Set up the select list and hook up a selection changed event
                    g_selColor = new Sys.UI.Select($('colorSelect'));
                    g_selColor.initialize();
                    g_selColor.selectionChanged.add(onSelectColor);

                    // Set up the textBox and set some properties on it
                    g_tbx = new Sys.UI.TextBox($('textBox')); 
                    g_tbx.initialize();
                    g_tbx.set_text("Simple text box control");
                    g_tbx.set_cssClass("textBox");
                    
                    // Set up the buttons and attach the click event
                    var btnCursor = new Sys.UI.Button($('cursorButton'));
                    btnCursor.initialize();
                    btnCursor.click.add(onCursorButtonClick);
                    
                    var btnVisibility = new Sys.UI.Button($('visibilityButton'));
                    btnVisibility.initialize();
                    btnVisibility.click.add(onSetVisibilityClick);
                    
                    var btnEnabled = new Sys.UI.Button($('enabledButton'));
                    btnEnabled.initialize();
                    btnEnabled.click.add(onSetEnabledClick);
                    
                    g_label = new Sys.UI.Label($('cursorLabel'));
                    g_label.initialize();
                    g_label.set_text("Regular pointer cursor");
                }
                        
                // Panel changes
                function onCursorButtonClick() {
                    if (g_panel.containsCssClass('special'))
                    {
                        g_panel.removeCssClass('special');
                        g_label.set_text("Regular cursor");
                    }
                    else
                    {
                        g_panel.addCssClass('special');
                        g_label.set_text("Hand pointer cursor");
                    }
                }

                function onSelectColor(sender, args) {
                    g_panel.set_cssClass(g_selColor.get_selectedValue());
                }
                // TextBox changes    
                function onSetVisibilityClick() {
                    g_tbx.set_visible(!g_tbx.get_visible());
                }
                    
                function onSetEnabledClick() {
                    g_tbx.set_enabled(!g_tbx.get_enabled());
                }
            </script>
        </div>
    </form>
</body>
</html>