<%@ Page Language="C#" AutoEventWireup="true" CodeFile="DataTableScript.aspx.cs" Inherits="Atlas_DataTableScript" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>DataBinding a ListBox to a DataTable</title>
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <atlas:ScriptManager ID="ScriptManager" runat="server">
            <Services>
                <atlas:ServiceReference Path="~/atlas/simpleservice.asmx" />
            </Services>
            <Scripts>
                <atlas:ScriptReference Path="~/scripts/AtlasProgressBar.js" />
            </Scripts>
        </atlas:ScriptManager>
        <h1>ATLAS Web Service Data Binding</h1>
        <br />
        <a href="../">Sample Home</a> | <a href="DataTableScript.aspx">Refresh Page</a> | <small>Page generated: <%= DateTime.Now %></small>
        <br />
        <br />
        <table cellpadding="10" width="800">
        <tr>
        <td valign="top">
        <b>Bind with JavaScript Code:</b><br />
        <asp:ListBox ID="lstCustomers" runat="server" Height="300px" Width="249px"></asp:ListBox>
        <br />
        <input type="button" Value="Get Customers" onclick="SimpleService.GetCustomerList(CustomerListCallback,OnTimeout,OnError);" />
        </td>
        <td valign="top">
        <b>Bind with XmlScript:</b><br />
        <asp:ListBox ID="lstCustomers2" runat="server" Height="300px" Width="249px"></asp:ListBox>
        <br />
        <input type="button" Value="Get Customers Databinding" onclick="SimpleService.GetCustomerList(CustomerList2Callback,OnTimeout,OnError);" />
        <br />
        <span id="lblSelection"></span>
        </td>
        </tr>
        </table>
    
    </div>
    
    <script>
    function CustomerListCallback(Result)
    {
        var Table = Result;
        var RowCount = Table.get_length();
        
        var List = $('lstCustomers') ;
        
        // *** Remove Items
        while (List.length > 0) 
        {   List.remove(0);   }
        
        for ( x=0; x < RowCount; x++)
        {
            var Row = Table.getItem(x);

            var opt = document.createElement('option');
            opt.value = Row.getProperty('CustomerId');
            opt.innerText = Row.getProperty('CompanyName');
            opt.text=opt.innerText;         // Mozilla doesn't want to work with innerText
            List.appendChild(opt);
        }
    }
     function OnTimeout(Result)
    {
        alert( Result.get_message() );
    }
    function OnError(Result)
    {
        alert( Result.get_message() );
    }
    function CustomerList2Callback(Result)
    {
        var List = $object('lstCustomers2');
        
        // *** Assign the Data and bind
        List.set_data(Result);
    }
    </script>
    
    <script type="text/xml-script">
        <page xmlns:script="http://schemas.microsoft.com/xml-script/2005">
            <components>
                <select id="lstCustomers2"
                    textProperty="CompanyName"
                    valueProperty="CustomerId"
                />
                <select id="lstCustomers">
                </select>
                <label id="lblSelection">
                    <bindings>
                        <binding dataContext="lstCustomers2"
                                 dataPath="selectedValue"
                                 property="text"
                                 />
                        <binding dataContext="lstCustomers"
                                 dataPath="selectedValue"
                                 property="text"
                                 />
                    </bindings>
                </label>            
           </components>
        </page>
    </script>
<%--
    <div style="width:400px;background:darkblue;color:cornsilk;" id="divProgressbar"></div>
        <atlas:UpdateProgress ID="UpdateProgress1" runat="server">
            <ProgressTemplate>
                Contacting server...
                <br />
                <br />
                <input id="abortButton" type="button" value="Abort Request" />
            </ProgressTemplate>
        </atlas:UpdateProgress>

--%>   
 </form>
</body>
</html>
