<%@ Page Language="C#" AutoEventWireup="true" CodeFile="LongProgress.aspx.cs" Inherits="Atlas_LongProgress" %>
<%@Register Src="~/ShowCode.ascx" TagPrefix="uc1" TagName="ShowCode" %> 

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>ATLAS Long Running Progress</title>
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="form1" runat="server">
        <div>
<atlas:ScriptManager ID="ScriptManager1" runat="server" EnableScriptComponents="true"
    EnablePartialRendering="true">
    <Services>
        <atlas:ServiceReference Path="~/atlas/simpleservice.asmx" />
    </Services>
    <Scripts>
        <atlas:ScriptReference Path="~/scripts/AtlasProgressBar.js" />
        <atlas:ScriptReference Path="~/scripts/AtlasToolTip.js" />
    </Scripts>
</atlas:ScriptManager>
            <h1>
                ATLAS Long Running Query Progress</h1>
            <a href="../default.aspx">Home</a> | <a href="LongProgress.aspx">Refresh Page</a>
            | <small>Page created at:&nbsp;<%= DateTime.Now %></small><br />
            <br />
            <br />
            <br />
            <blockquote>
                &nbsp;
                <center>
                <input type="button" id="btnStartProcessing" value="Start Long Query" 
                       onclick="StartRequestProcessing();" />
                <input type="button" id="btnCancelProcessing" value="Cancel Request" 
                             onclick="CancelRequestProcessing();" />
                <p />
                <atlas:UpdatePanel Mode="Conditional" runat="server" ID="updatePanel">
                    <Triggers>
                        <atlas:ControlEventTrigger ControlID="btnComplete" EventName="Click" />
                    </Triggers>
                    <ContentTemplate>
                        <div id="ProgressContainer" class="blackborder" style="padding: 10px; width: 500px;
                            height: 35px; background: cornsilk; border: solid 1px black;text-align:left;display:none;" runat="server">
                            <div style="text-align:center">
                            <asp:Label ID="lblMessage" runat="server" CssClass="errormessage"  style="text-align:center"></asp:Label>
                            </div>
                            <div id="ProgressBar" style="border: solid 1px black; background: blue; height: 30px;
                                width: 0px; color: cornsilk; text-align: right; font-weight: bold;">
                            </div>
                        </div>
                        <br />
                        <asp:GridView ID="gdCustomers" runat="server" CssClass="blackborder" Width="738px" style="text-align:left">
                            <HeaderStyle CssClass="gridheader" />
                            <AlternatingRowStyle CssClass="gridalternate" />
                        </asp:GridView>
                        </center>
                        </center>
                        <asp:Button runat="server" ID="btnComplete"  style="display:none" OnClick="btnComplete_Click" Text="Completion (hidden)" />
                    </ContentTemplate>
                </atlas:UpdatePanel>
                    
                <br />
            </blockquote>
            <p>
                &nbsp;</p>
            <p>
                &nbsp;</p>
            <asp:HiddenField ID="txtRequestKey" runat="server" />
            
            
        <p />
        <blockquote>
        <hr />
        This example demonstrates using JavaScript code, some of the ATLAS client framework and a custom ATLAS 
        client control to demonstrate mixing both client and server technologies in one place. 
        <p />
        It's also a useful example that demonstrates how to display progress information on a page using 
        a message table that is used to pass messages between the processing application and the page which
        requests status updates. These updates provide status information as well as a percentage which is
        display in a custom ATLAS ProgressBar control.
        <hr />
        </blockquote>
        
        <uc1:ShowCode ID="ShowCode2" runat="server" CodeFile="~/atlas/LongProgress.aspx"
            Text="Show ASPX" />
        <uc1:ShowCode ID="ShowCode1" runat="server" CodeFile="~/atlas/LongProgress.aspx.cs"
            Text="Show Code" />
            
            <script type="text/javascript">
// *** Global Controls
 var Progress = null;
 var ToolTip = null;

// *** Global Request Key that identifies this request
var RequestKey = "";
 
// *** Flag that keeps track that we're busy
var busy = false;

function StartRequestProcessing()
{
    Progress = new Sys.UI.ProgressBar($('ProgressBar'));
    Progress.set_progress(0);

    $('ProgressContainer').style.display='';
    $('ProgressBar').style.display='';
    
    var Grid = $('gdCustomers');
    if (Grid)
        Grid.style.display = 'none';
        
    $('btnStartProcessing').disabled = true;
    
    // *** Call [WebMethod] returns Request Key
    PageMethods.StartRequestProcessing(StartRequestProcessingCallback);
}
function StartRequestProcessingCallback(Result)
{
    Progress.set_progress(0);
    RequestKey = Result;
    if (RequestKey == null)
        alert("Processing couldn't start" );
    
    // *** Get current status with another callback
    GetRequestStatus();
}
function GetRequestStatus()
{
    if (RequestKey == null || RequestKey == "")
        return;
    
    // *** Call [WebMethod] and return a RequestStatus object    
    PageMethods.GetRequestStatus(RequestKey,GetRequestStatusCallback);
}
function GetRequestStatusCallback(Result)
{
    var ctlMessage = $('lblMessage');
    
    // *** Possible timing issue
    if (Result == null)
    {
        window.setTimeout('GetRequestStatus();',1000);
        return;
    }
        
    if (Result.Status == "Cancelled")
    {
        ctlMessage.innerHTML = Result.Message;
        Progress.set_progress(Result.Percent);
        RequestKey = "";
        busy = false;
        $('btnStartProcessing').disabled = false;
        return;
    }
    if (Result.Status == "Completed")
    {
        Progress.set_progress(100);
        ctlMessage.innerHTML = Result.Message;
        
        // *** Set hidden field so we have a value on the server
        $('txtRequestKey').value = RequestKey;
        
        // *** Force button to click in UpdatePanel
        $('btnComplete').click();
        
        busy = false;
        $('btnStartProcessing').disabled = false;
        return;
    }
    
    ctlMessage.innerHTML = Result.Message;
    
    // *** Queue it back up for the next request
    Progress.set_progress(Result.Percent);
    if (Result.Percent < 100)
        window.setTimeout('GetRequestStatus();',1000);
    else
        busy = false;        
}
function CancelRequestProcessing()
{
    // *** Call and forget - no callback function
    PageMethods.CancelRequestProcessing(RequestKey);
}
function OnError(Result)
{
    alert( Result.get_message() );    
}


// *** Example of custom ProgressBar Control 
//function ShowProgress()
//{
//    if (Progress == null)
//    {
//        Progress = new Sys.UI.ProgressBar($('ProgressBar'));
//        Progress.initialize();
//    }
//    if (ToolTip == null)
//    {
//        ToolTip = new Sys.UI.ToolTip($('ProgressBar'));
//        ToolTip.initialize();
//    }
//    
//    ToolTip.set_message('Getting Started...');
//    ToolTip.show();
//        
//    SimpleService.InitializeProgressInfo(0);
//    
//    Progress.set_interval(2000);
//    Progress.set_serviceURL("simpleservice.asmx");
//    Progress.set_serviceMethod("ProgressInfo");
//    Progress.start();
//    
//}
            </script>
      
    </form>
</body>
</html>
