<%@ WebService Language="C#" Class="SimpleService" %>
using System;

using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;

using System.Data;

using Westwind.BusinessObjects;
using ScriptCallbacks.BusinessObjects;


/// <summary>
/// Summary description for SimpleService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class SimpleService : System.Web.Services.WebService
{
    [WebMethod]
    public string HelloWorld(string Name)
    {
        return "Hello " + Name + ". " + DateTime.Now.ToString();
    }

    [WebMethod]
    public DataTable GetCustomerList()
    {
        busCustomer Customer = new busCustomer();
        if (Customer.GetCustomerList() < 0)
            throw new ApplicationException("Unable to load customers: " + Customer.ErrorMessage);

        return Customer.DataSet.Tables["TCustomerList"];
    }

    [WebMethod]
    public CustomersRow GetCustomer()
    {
        //throw new Exception("Failure dude!"); //, SoapException.ServerFaultCode);

        busCustomer Customer = new busCustomer();
        Customer.New();

        Customer.Entity.Companyname = "West Wind";
        Customer.Entity.Contactname = "Rick Strahl";

        return Customer.Entity;
    }

    [WebMethod]
    public string SaveCustomer(CustomerEntity CustomerEntity)
    {
        busCustomer Customer = new busCustomer();
        Customer.GetBlankRecord();

        Customer.Entity = CustomerEntity;
        return Customer.Entity.Companyname;
    }

    [WebMethod(true)]
    public void InitializeProgressInfo(int Value)
    {
        Session["Progress_Value"] = Value;
    }
    
    [WebMethod(true)]
    public int ProgressInfo()
    {
        int ProgressValue = 0;
        
        object TVal = Session["Progress_Value"];
        if (TVal != null)
            ProgressValue = (int)TVal;
        
        ProgressValue += 5;
        if (ProgressValue > 100)
            ProgressValue = 100;
            
        Session["Progress_Value"] = ProgressValue;

        return ProgressValue;
    }
}
