<%@ Page Language="C#" AutoEventWireup="true" CodeFile="StockDisplay.aspx.cs" Inherits="StockDisplay" %>
<%@Register Src="~/ShowCode.ascx" TagPrefix="uc1" TagName="ShowCode" %> 
<%@ Register Assembly="wwWebControls" Namespace="Westwind.Web.Controls" TagPrefix="ww" %>
<%@ Assembly Name="Microsoft.Office.Interop.Owc11, Version=11.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c"  %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Stock Listing</title>
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
    <style>
    BODY,TD,INPUT { font-size:8ptem; }
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <atlas:ScriptManager ID="ScriptManager" runat="server" EnablePartialRendering="true">
                <Services>
                    <atlas:ServiceReference Path="~/atlas/StockService.asmx" />
                </Services>
                <Scripts>
                    <atlas:ScriptReference Path="~/scripts/AtlasToolTip.js" />
                </Scripts>
                <ErrorTemplate>
                    <div class="errordisplay" style="padding:20px">
                        <h1>A callback error occurred</h1>
                        <hr />
                        <span id="errorMessageLabel"></span>
                        <button type="button" id="okButton" onclick="Sys.WebForms.PageRequestManager.clearError();">
                            Click here to continue</button>
                    </div>
                </ErrorTemplate>
            </atlas:ScriptManager>
            <h1>
                ATLAS Stock Retrieval Service</h1>
            <table width="100%" cellpadding="5">
                <tr>
                    <td valign="top" class="gridalternate" style="width: 200px;" height="800">
                        <br />
                        Your Email Address:<br />
                        <asp:TextBox ID="txtEmail" runat="server" Width="168px"></asp:TextBox><br />
                        <br />
                        Quick Stock Lookup:<br />
                        <asp:TextBox ID="txtQuoteSymbol" runat="server" Width="114px"></asp:TextBox><input
                            id="btnQuickQuote" type="button" value="Get" onclick="this.disabled=true;StockService.GetStockQuote(document.getElementById('txtQuoteSymbol').value,QuickQuoteCallback,null,OnError);"
                            style="width: 50px" /><br />
                        <br />
                        <!-- Update with manual Web Service Calls -->
                        <div>
                            <table cellpadding='4' class='blackborder' width='190' align='center' style='background: cornsilk'>
                                <tr>
                                    <td class='smallbody' nowrap colspan='2' id="tdStockName">
                                        <span id='lblStockName' onmouseover="QuickQuotePopup();" onmouseout="QuickQuotePopupHide();">
                                        </span><span id="lblQuickQuoteSymbol" style="display: none"></span>
                                        <asp:Image runat="server" ID="imgQuickQuoteHistory" Style="display: none; position: absolute;
                                            border: solid 2 bordershadow;" onmouseout="QuickQuotePopupHide();" />
                                    </td>
                                </tr>
                                <tr>
                                    <td class='smallbody'>
                                        Last Price:</td>
                                    <td class='smallbody' id='tdLastPrice'>
                                    </td>
                                </tr>
                                <tr>
                                    <td class='smallbody'>
                                        Open Price:</td>
                                    <td class='smallbody' id='tdOpenPrice'>
                                    </td>
                                </tr>
                                <tr>
                                    <td class='smallbody' style="height: 21px">
                                        Quote Time:</td>
                                    <td class='smallbody' id='tdLastQuoteTime' style="height: 21px">
                                    </td>
                                </tr>
                            </table>
                        </div>
                        <!--  Web Service Update Quote Service -->
                        <br />
                        <!--  Timer Triggered UpdatePanel -->
                        <atlas:UpdatePanel ID="upanelCloseTime" runat="server">
                            <ContentTemplate>
                                <table width="190" align="center" cellpadding="4" class="blackborder" style="background: cornsilk;">
                                    <tr>
                                        <td align="center">
                                            <asp:Label ID="lblCloseTime" runat="server" CssClass="smallbody"></asp:Label>
                                        </td>
                                    </tr>
                                </table>
                            </ContentTemplate>
                            <Triggers>
                                <atlas:ControlEventTrigger ControlID="CloseTimeTimer" EventName="Tick" />
                            </Triggers>
                        </atlas:UpdatePanel>
                        <!-- Timer Triggered UpdatePanel -->
                    </td>
                    <td valign="top" style="padding-left: 20px; padding-top: 10px;">
                        <a href="../default.aspx">Sample Home</a> | <a href="StockDisplay.aspx">Refresh Page</a>
                        | <small>Page generated @
                            <%= DateTime.Now %>
                        </small>
                        <atlas:UpdateProgress ID="UpdateProgress1" runat="server">
                            <ProgressTemplate>
                                <small style="position: absolute; right: 80px;">
                                    <asp:Image ID="Image1" runat="server" ImageUrl="~/images/working_small.gif" />
                                    Updatating...</small>
                            </ProgressTemplate>
                        </atlas:UpdateProgress>
                        <atlas:UpdatePanel ID="upanelPortfolio" runat="server" Mode="Conditional">
                            <ContentTemplate>
                                <P />
                                <h2 style="text-align:center">My Stock Portfolio</h2>
                                <br />
                                <ww:wwErrorDisplay ID="ErrorDisplay" runat="server" Width="450">
                                </ww:wwErrorDisplay>
                                <br />
                                <asp:LinkButton ID="btnRefresh" runat="server" Text="Refresh Portfolio" OnClick="btnRefresh_Click" />
                                | <a href="javascript:;" onclick="javascript:$('divAddStock').style.display=''" accesskey="A">Add new
                                    stock</a> |
                                <asp:CheckBox ID="chkGraph" runat="server" Text="Graph 2 year history" AutoPostBack="True" 
                                              OnCheckedChanged="chkGraph_CheckedChanged" />
                                | <small>Stock data courtesy of <a href="http://finance.yahoo.com/">Yahoo Finance</a></small>
                                
                                
                                <asp:Panel runat="server" ID="divAddStock" class="blackborder" Style="display: none;
                                    padding: 8px; margin: 10px; width: 300px; margin-top: 5px; border: solid 2px DarkBlue;
                                    background: cornsilk">
                                    <b>Add new Stock Symbol to your Portfolio</b>
                                    <hr />
                                    <b>Symbol:</b>
                                    <asp:TextBox runat="server" ID="txtAddStockSymbol" Width="80" onblur="CheckStockDupe();"></asp:TextBox>
                                    <b>Qty:</b>
                                    <asp:TextBox runat="server" ID="txtNewStockQty" Width="30"></asp:TextBox>
                                    <asp:Button runat='server' ID="btnAddStock" Text="Add" AccessKey="A" OnClick="btnAddStock_Click" />
                                </asp:Panel>
                                <asp:GridView ID="grdStocks" runat="server"  CssClass="blackborder" AutoGenerateColumns="false"
                                    CellPadding="5" ShowFooter="True" AutoGenerateEditButton="True" AutoGenerateDeleteButton="true"
                                    OnRowEditing="grdStocks_RowEditing" OnRowUpdating="grdStocks_RowUpdating" OnRowCancelingEdit="grdStocks_RowCancelingEdit"
                                    OnRowDeleting="grdStocks_RowDeleting" Style="margin-top: 5px" GridLines="vertical">
                                    <HeaderStyle CssClass="gridheader"  Width="700px" />
                                    <AlternatingRowStyle CssClass="gridalternate" />
                                    <EmptyDataTemplate>
                                        Your stock portfolio is currently empty. Add a symbol and qty on the left
                                    </EmptyDataTemplate>
                                    <Columns>
                                        <asp:BoundField DataField="Symbol" HeaderText="Symbol" HeaderStyle-HorizontalAlign="Right">
                                        </asp:BoundField>
                                        <asp:BoundField DataField="Name" HeaderText="Company" ReadOnly="true">
                                            <ItemStyle Width="200px" />
                                           <HeaderStyle  HorizontalAlign="Left" />
                                        </asp:BoundField>
                                        <asp:TemplateField HeaderText="Updated">
                                            <HeaderStyle Width="100" />
                                            <ItemStyle  Font-Size="8pt" />
                                            <ItemTemplate>
                                                <%# ((DateTime)Eval("LastQuoteTime")).ToString("MM/dd hh:mmtt").ToLower() %>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:BoundField DataField="Qty" HeaderText="Qty" HeaderStyle-HorizontalAlign="right">
                                            <ItemStyle Width="50px" HorizontalAlign="right" />
                                        </asp:BoundField>
                                        <asp:BoundField DataField="LastPrice" HeaderText="Price" ReadOnly="true">
                                            <HeaderStyle HorizontalAlign="Right" Width="80px" />
                                            <ItemStyle HorizontalAlign="Right"  />
                                        </asp:BoundField>
                                        <asp:BoundField DataField="Total" DataFormatString="{0:n}" HeaderText="Position"
                                            HtmlEncode="False" ReadOnly="true">
                                            <HeaderStyle HorizontalAlign="Right" Width="100px" />
                                            <ItemStyle HorizontalAlign="Right"  />
                                        </asp:BoundField>
                                    </Columns>
                                    <FooterStyle CssClass="blockheader" />
                                </asp:GridView>
                                <p>
                                </p>
                            </ContentTemplate>
                       </atlas:UpdatePanel>
                       <atlas:UpdatePanel runat="server" ID="UpdatePanelHistoryGraph" 
                                Mode="Conditional">
                        <Triggers>
                            <atlas:ControlEventTrigger ControlID="chkGraph" EventName="CheckedChanged" /> 
                        </Triggers>
                        <ContentTemplate>
                                <asp:Image runat="server" ID="imgHistory" Visible="false" align="center" />
                        </ContentTemplate>
                        </atlas:UpdatePanel>
                        <br />
                        <hr />
                        <div class="errordisplay" style="font-weight:normal">
                        <b>Note:</b><br />
                        This sample requires the <a href="http://tinyurl.com/5dfrx">Office Web Components
                            Version 11</a> which are used for the charting samples.<br />
                        </div>
                        <br />
                        This example demonstrates a variety of ATLAS features including direct Web Service
                        access for retrieving individual stocks and the stock symbol duplicate validation,
                        Timer and UpdatePanel for refreshing market close times, UpdatePanel for refreshing
                        the stock portfolio content and DataGrid as well as the History chart, a custom
                        client control for ToolTip behavior. This sample is meant to demonstrate how the
                        server side and client side mechanisms can easily co-exist.<br />
                        <hr />
                        <atlas:UpdatePanel runat="server" id="UpdatePanelCodeButtons" Mode="Conditional">
                            <ContentTemplate>
                            <uc1:ShowCode ID="ShowCode1" runat="server" CodeFile="~/atlas/StockDisplay.aspx.cs"
                                Text="Show Code" />
                            <uc1:ShowCode ID="ShowCode2" runat="server" CodeFile="~/atlas/StockDisplay.aspx"
                                Text="Show ASPX" />
                            </ContentTemplate>
                        </atlas:UpdatePanel>
                    </td>
                </tr>
            </table>
            <atlas:TimerControl ID="CloseTimeTimer" runat="server" OnTick="CloseTimeTimer_Tick">
            </atlas:TimerControl>
        </div>

        <script type="text/javascript">
function GetQuotes()
{

}
function QuickQuoteCallback(Result)
{
    // *** Using stock DOM objects 
    document.getElementById('tdLastPrice').innerHTML = Result.LastPrice.toString();

    // *** Using ATLAS $() - equivalent to document.getElementById()
    $('lblQuickQuoteSymbol').innerHTML = Result.Symbol;
    $('tdOpenPrice').innerHTML = Result.OpenPrice.toString();
    $('tdLastQuoteTime').innerHTML = Result.LastQuoteTimeString ;

    // *** Using Atlas Sys.UI control - browser independent control model
    var lblStockname = new Sys.UI.Label($('lblStockName'));
    lblStockname.initialize();     
    lblStockname.set_text(Result.Company + " (" + Result.Symbol + ")<hr>");
    lblStockname.set_cssClass('errormessage');
    lblStockname.get_style().fontSize="8pt";
    
    // *** Re-enable the Get button
    $('btnQuickQuote').disabled = false;
}

var QuickQuoteGraphActive = false;
function QuickQuotePopup(event)
{
    if (QuickQuoteGraphActive)
        return;

    var Symbol = $('lblQuickQuoteSymbol').innerHTML;
    if (Symbol == null || Symbol == "")
        return;
    QuickQuoteGraphActive = true;
    
    window.setTimeout("QuickQuoteGraph('" + Symbol + "')",10)
}
function QuickQuoteGraph(Symbol)
{
    StockService.CreateStockHistoryGraph([Symbol],"",210,200,1,"temp",OnQuickQuoteGraphCallbackComplete,OnTimeOut,OnError);
}
function OnQuickQuoteGraphCallbackComplete(Result)
{
    var Image = $('imgQuickQuoteHistory');
    Image.src= Result;    
    Image.style.display = '';
    window.setTimeout('QuickQuoteGraphActive = false;',1000);
}
function QuickQuotePopupHide(event)
{
    var Image = $('imgQuickQuoteHistory');
    Image.style.display = 'none';
    QuickQuoteGraphActive=true;
    
    // *** second delay before next view
    window.setTimeout("QuickQuoteGraphActive=false;",1000);
}
function CheckStockDupe()
{
    var Ctl = $('txtAddStockSymbol');
    if (Ctl.value == null || Ctl.value == "")
        return; // *** Don't check unless there's something to do
        
    StockService.CheckStockForDupe($('txtEmail').value,Ctl.value,CheckStockDupeCallback,OnTimeOut,OnError);
}
function CheckStockDupeCallback(Result)
{
    if (Result) 
    {
       ShowToolTip('txtAddStockSymbol','Stock symbol is already in the list.',3000,'BottomLeft');
       
//       var ToolTip = new Sys.UI.ToolTip( $('txtAddStockSymbol') );
//       ToolTip.set_message('Sock symbol already in the list.');
//       ToolTip.set_timeout(3000);
//       ToolTip.show();
    }
}

function OnTimeOut(Result)
{
   $('btnQuickQuote').disabled = false;
    alert('Callback timed out.');
}
function OnError(Result)
{
    $('btnQuickQuote').disabled = false;
    alert(Result.get_message());
}


// Utility function - ShowToolTip to display Tooltip
//                    message on a control
function ShowToolTip(ControlId,Message,Timeout,Position)
{
    var Ctl = $(ControlId);
    if (Ctl == null)
        return;
    
    var ToolTip = $(ControlId + "_ToolTip")
    var Shadow = $(ControlId + "_ToolTipShadow")
    var Added = false;
    if ( Shadow == null)
        Shadow = document.createElement('div');
    if ( ToolTip == null)
    {
       ToolTip = document.createElement('div');
       Ctl.parentNode.appendChild(Shadow);
       Ctl.parentNode.appendChild(ToolTip);
    }
    if ( Position == null)
        Position = "BottomLeft";
        
    var Style=ToolTip.style;    
    var Style2=Shadow.style;    
    Style.display = '';
    Style2.display = '';
    Style.width='';
    Style.height='';
    
    ToolTip.id = ControlId + "_ToolTip";
    Style.background = "cornsilk";
    Style.color = "black";
    Style.borderWidth="1px";
    Style.borderStyle="solid";
    Style.borderColor="gray";
    Style.padding="2";
    Style.fontSize = "8pt";
    Style.fontWeight = "normal";

    var OldPosition=Ctl.style.position;
    
    Ctl.style.position = "absolute";
    ToolTip.innerHTML = Message;
    Style.position = "absolute";

    var Left = Ctl.offsetLeft + 10;
    var Top = Ctl.offsetTop + Ctl.offsetHeight - 5;
    if( Position == "BottomRight")
    {
        Left = Ctl.offsetLeft + Ctl.offsetWidth - 10;
        Top = Ctl.offsetTop + Ctl.offsetHeight - 5;
    }
    else if (Position == "TopLeft")
    {
        Left = Ctl.offsetLeft + 2;
        Top = Ctl.offsetTop + 2;
    }
    else if( Position == "Mouse")
    {
        if (window.event) 
        {
            Left = window.event.clientX;
            Top = window.event.clientY;
        }
    }
    var Width = ToolTip.offsetWidth + 2;  // Message.length * 6.5;
    if (Width > 400)
        Width=400;
    
    Style.left = Left + "px";
    Style.top = Top + "px";
    Style.width= Width + "px";
   
    Shadow.id = ControlId + "_ToolTipShadow";
    Style2.position = "absolute";
    Style2.background = "silver";
    Style2.left = Left + 2 + "px";
    Style2.top = Top + 2 + "px";
    Style2.width = ToolTip.offsetWidth + "px";
    Style2.height = ToolTip.offsetHeight + "px";
    
    Ctl.style.position = OldPosition;    
    
    if (Timeout && Timeout > 0)
        window.setTimeout("HideToolTip('" + ControlId + "');",Timeout);
}
function HideToolTip(ControlId)
{
    var Ctl = $(ControlId +  "_ToolTip");
    if (Ctl == null)
        return;
    Ctl.style.display="none";
    Ctl = $(ControlId +  "_ToolTipShadow").style.display="none";
}
function ShowAtPosition(ControlId,x,y)
{
    var Ctl = $(ControlId);
    if (Ctl == null)
        return;

    Ctl.style.position="absolute";
    Ctl.style.display="";

    Ctl.style.left = x + "px";
    Ctl.style.top = y + "px";
}

        </script>

        <%--<script type="text/xml-script">
    <page xmlns:script="http://schemas.microsoft.com/xml-script/2005">
        <components>
            <control id="panelQuickQuoteHistory">
                <behaviors>
                    <popupBehavior id="popupBehavior" parentElement="lblStockName"  positioningMode="bottomRight"/>
                </behaviors>
            </control>
            <label id="lblStockName">
            <behaviors>
                <hoverBehavior unhoverDelay="300" hoverElement="panelQuickQuoteHistory">
                    <hover>
                        <invokeMethod target="popupBehavior" method="show"/>
                    </hover>
                    <unhover>
                        <invokeMethod target="popupBehavior" method="hide"/>
                    </unhover>
                </hoverBehavior>
            </behaviors>
        </label>
       </components>
    </page>
</script>
--%>
    </form>
</body>
</html>
