<%@ WebService Language="C#" Class="StockService" %>

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

using System.Net;
using System.Text;
using System.Globalization;

using System.IO;
using System.Collections.Generic;
using Microsoft.Office.Interop.Owc11;

[WebService(Namespace = "http://www.west-wind.com/scriptcallbacks/atlas/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class StockService : System.Web.Services.WebService
{
    StockServer Server = new StockServer();
    
    [WebMethod]
    public StockQuote GetStockQuote(string Symbol)
    {
        return Server.GetStockQuote(Symbol);
    }
    
    /// <summary>
    /// 
    /// </summary>
    /// <param name="Symbols"></param>
    /// <returns></returns>
    [WebMethod]
    public StockQuote[] GetStockQuotes(string[] Symbols)
    {
        return Server.GetStockQuotes(Symbols);
    }

    /// <summary>
    /// Returns the stock history for the last year
    /// http://itable.finance.yahoo.com/table.csv?s=MSFT&g=m&q=q&a=0&b=1&c=2005&d=3&e=10&&f=2006&
    /// </summary>
    /// <param name="Symbol"></param>
    /// <returns></returns>
    [WebMethod]
    public StockHistory[] GetStockHistory(string Symbol,int Years)
    {
        return Server.GetStockHistory(Symbol, Years);
    }

    /// <summary>
    /// This method retrieves Stock History for several symbols
    /// and then generates a chart into a specified directory
    /// The method returns a link to the image generated
    /// </summary>
    /// <param name="Symbols"></param>
    /// <returns></returns>
    [WebMethod]
    public string CreateStockHistoryGraph(string[] Symbols,string Title,int Width,int Height,int Years,string ImagePath)
    {
        return Server.CreateStockHistoryGraph(Symbols, Title, Width, Height, Years, ImagePath);
    }            

    [WebMethod]
    public StockQuote[] TestGetQuotes()
    {
        //return this.GetStockQuotes(new string[3] { "MSFT", "HPQ", "INTC" });
        this.CreateStockHistoryGraph(new string[3] { "MSFT", "HPQ", "INTC" },"Portfolio History",400,300,2,"temp/");
        return null;
    }

    [WebMethod]
    public string TimeUntilClose()
    {
        return Server.TimeUntilClose();
    }

    [WebMethod]
    public bool CheckStockForDupe(string Email, string Symbol)
    {
        busStockData StockData = new busStockData();
        return StockData.LoadByEmailAndSymbol(Email, Symbol);
    }
}