﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="InvoiceList.aspx.cs" Inherits="InvoiceList" enableviewstate="false" EnableEventValidation="false" %>

<%@ Register Src="~/ShowCode.ascx" TagName="ShowCode" TagPrefix="uc1" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Invoice List</title>
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
    <style>
      TABLE.blackborder TD,TH { FONT-SIZE: 0.82em; FONT-FAMILY: Tahoma,Verdana,Arial }
	</style>
</head>
<body>
    <form id="form1" runat="server">

<script type="text/javascript">
var LastMouseTop = 0;
var LastMouseLeft = 0;
var OrderId = 0;
function ShowLineItems(InvId,event)
{   
    if (event != null)  
    {
        LastMouseTop = event.clientY;  
        LastMouseLeft = event.clientX;
    }
    OrderId=InvId;
    
    // *** Delay calling the window for a half second    
    window.setTimeout("<%= this.CallBackEventReference %>",500);
}
function HideLineItems() 
{
    document.getElementById('LineItemPlaceHolder').style.display = 'none';
}
function DisplayLineItems() 
{
    document.getElementById('LineItemPlaceHolder').style.display = '';
}
function OnLineItemView(Result,Context) 
{       
    var Panel = document.getElementById('LineItemPlaceHolder');
    if (Panel == null)
        return;
  
    Panel.innerHTML = Result;
    if (LastMouseTop != 0) 
    {
        Panel.style.top = (LastMouseTop + 2) + "px";
        Panel.style.left = (LastMouseLeft + 2) + "px";
    }     
    Panel.style.display = '';
}
</script>	

<!-- *** Panel we'll load data into -->
<div style="position:absolute;top:3px;left:4px;width:500;border:solid 1px darkblue;display:none" 
     id="LineItemPlaceHolder" 
     onmouseover="DisplayLineItems();"  
     onmouseout="HideLineItems();">
</div>
    
    <div>
        <h1>
            Northwind Invoice Listing</h1>
        <br />
            <a href="../default.aspx">Home</a> | <asp:CheckBox ID="chkFullInvoice" runat="server" Text="Show Full Invoice Page" AutoPostBack="True" /><p/>
        
            &nbsp;&nbsp;<asp:Label ID="lblErrorMessage" runat="server" CssClass="ErrorMessage" Width="457px" Visible="False"></asp:Label>
    
    </div>
        <asp:GridView ID="gvInvoiceList" runat="server"  CellPadding="3" CssClass="blackborder" AutoGenerateColumns=false Width="95%" 
                      HorizontalAlign="Center" AllowPaging="True" 
                      OnPageIndexChanging="gvInvoiceList_PageIndexChanging" PagerSettings-Mode="NumericFirstLast" PageSize="10">
            <FooterStyle cssclass="gridheader"/>
            <PagerStyle cssclass="gridheader"  ForeColor="white" HorizontalAlign="right" />
            <AlternatingRowStyle CssClass="gridalternate" />
            <HeaderStyle cssclass="gridheader"  Font-Bold="True" />
            <Columns>
                <asp:TemplateField  ItemStyle-HorizontalAlign="Center">
                <HeaderTemplate>Invoice No.</HeaderTemplate>
                <ItemTemplate>
                	<a href='ShowInvoice.aspx?id=<%# Eval("OrderId") %>'  
                	   onmouseover='ShowLineItems("<%# Eval("OrderId")  %>",event)' 
                	   onmouseout='HideLineItems();'><%# Eval("OrderId") %></a>
                </ItemTemplate>
                    <ControlStyle Width="200px" />
				</asp:TemplateField>

                <asp:TemplateField >
                <HeaderTemplate>Date</HeaderTemplate>
                <ItemTemplate>
                			<%# ((DateTime)Eval("OrderDate")).ToString("d") %>
                </ItemTemplate>
				</asp:TemplateField>
                
                <asp:TemplateField >
                <HeaderTemplate>Company</HeaderTemplate>
                <ItemTemplate>
                			<%# Eval("Company") %>
                </ItemTemplate>
				</asp:TemplateField>

                <asp:TemplateField >
                <HeaderTemplate>Name</HeaderTemplate>
                <ItemTemplate>
                			<%# Eval("Name") %>
                </ItemTemplate>
				</asp:TemplateField>

                <asp:TemplateField ItemStyle-HorizontalAlign="Right" >
                <HeaderTemplate>Order Total</HeaderTemplate>
                <ItemTemplate>
                			<%# ((decimal)Eval("OrderTotal")  + (decimal) Eval("Freight")).ToString("n2") %>
                </ItemTemplate>
				</asp:TemplateField>
            </Columns>
        </asp:GridView>
        <br />
        <hr />
        <blockquote>
        This demo demonstrates how to pull dynamic content without refreshing
        the current page. To try this demo hove over the Invoice Number link - you should
        see a list of line items pop up ontop of the current form as a hover display that
        is mouse sensitive. This is an effective way to display content more easily than
        clicking through into a page and then navigate back. Rather this mechanism makes
        for a more efficient browser experience.
        </blockquote>
        <hr />
        <uc1:ShowCode ID="ShowSource" runat="server" CodeFile="~/scriptCallbacks/InvoiceList.aspx.cs" />
        <uc1:ShowCode ID="ShowAspx" runat="server" CodeFile="~/scriptCallbacks/invoicelist.aspx" Text="Show ASPX" />
    </form>
</body>
</html>
