﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="InvoiceLookup.aspx.cs" 
         Inherits="InvoiceLookup" enableviewstate=false  
         EnableEventValidation="false"%>
<%@ Register Tagprefix="ww" tagname="ShowCode" Src="~/ShowCode.ascx" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Customers and Invoices</title> 
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
</head>
<body onload="document.getElementById('txtCustomerPk').onchange();">
    <h1>
        Dynamic Customer Invoice Lookup</h1>
         &nbsp;<a href="../default.aspx">Home</a>
    <form id="InvoiceLookupForm" runat="server">
<script type='text/javascript'>
var RemovingItems = false;

// *** this function receives the server response as
// *** a string list with line pairs. First line is the
// *** Customer Id, second line is the string to display.
// *** this routine parses the list by adding items into
// *** dropdown list items collection.
function OnCustomerSelectionCallback(Result,Context)
{

    if (RemovingItems)
        return;
  
    var List = document.getElementById('txtInvoiceList');
    if (List) 
    { 
            RemovingItems = true;
            while (List.length > 0) 
            {   List.remove(0);   }
        
            if( Result.substr(0,6) == 'Error:' ) 
            {
                alert(Result);
                RemovingItems = false;
                return;  
            }
          
            var StringList = Result.split('\r\n');
 
            var x = 0;
            while(x < StringList.length)  
            {
                  var Pk = StringList[x];
                  if (Pk == '')
                    break;
                  
                  var Text = StringList[x+1];
                  AddItem(Text,Pk,List);
                  
                  // *** Skip to the next array item
                  x = x +2;          
            }
            
            // *** want to hide invoice detail
            if (x > 0)  
            {
               // *** assign value to cause onchange to fire
               List.selectedIndex = 0;

                // *** Causes an error - 
                // *** Script Callbacks don't support nested callbacks
                // *** List Onchange fires another callback here
               //List.onchange();
               
               // *** Work around bug with simultaneous callbacks
               window.setTimeout("document.getElementById('txtInvoiceList').onchange()",100);
            }
            
            //window.setTimeout('RemovingItems=false',500);
    }
    RemovingItems = false;
}
function AddItem(Text,Value,List) 
{
    var opt;
    opt = document.createElement('option');
    opt.value = Value;
    opt.innerText = Text;  // IE doesn't want to work with text only
    opt.text=Text;         // Mozilla doesn't want to work with innerText
    List.appendChild(opt);
}
// *** This function demonstrates a callback that 
// *** uses HTML from the server to replace the
// *** <select> object which means that all the parsing
// *** occurs on the server.
// *** Often times it's much easier to do this than
// *** parsing strings on the client. The code below
// *** is simpler and more easily transportable.
function OnCustomerSelectionHtmlCallback(Result,Context)
{
    List = document.getElementById('txtInvoiceList')
    if (List) 
    {
        ListDiv = document.getElementById('divInvoiceList')
  
        if (ListDiv) 
        { 
            // *** Pick up the <select> list inside the <div> tag
            var Output = ListDiv.innerHTML;     
            var StartIndex = Output.toLowerCase().indexOf("<option");
            if (StartIndex < 0) 
                StartIndex = Output.toLowerCase().indexOf("</select>");

            // *** and replace it with the HTML result from the server
            // *** server sends only the <option> groups.
            if (StartIndex > -1)
            {                
                // *** Replace the <option> list
                Output = Output.substring(0,StartIndex) + Result + "</select>";
                ListDiv.innerHTML = Output;
                
                List = document.getElementById('txtInvoiceList')
                if (List)
                {
                    // *** Force the lineitems to refresh
                    List.selectedIndex = 0;
                    //List.onchange();
                    
                    // *** Shouldn't nest callbacks
                    window.setTimeout("document.getElementById('txtInvoiceList').onchange()",20);
                }
            }
        }
    }
}

// *** This function simply receives ready-made Html from
// *** from the server for the invoice list. The table
// *** is simply placed into the placeholder <div> tag.
function OnInvoiceSelectionCallback(Result,Context) 
{
    Detail = document.getElementById('InvoiceDetail')
    Detail.style.display='';
    Detail.innerHTML = Result;
}
</script>
    <div style="margin-left:20px;margin-right:10px">
        <br />
        <asp:Label ID="lblErrorMessage" runat="server" CssClass="errormessage" Visible="False"></asp:Label><br />
       
       <center>
        <table class="blackborder" cellpadding="10" style="background:#eeeeee;text-align:left; height: 439px;">
        <tr><td style="height: 442px" valign="top">
        <b>Select a Customer:</b><br />
        <asp:DropDownList ID="txtCustomerPk" runat="server" Width="500px" >
        </asp:DropDownList><br />
        <br />
        <b>Invoices for this customer:</b><br />
        <div id="divInvoiceList">
        <asp:ListBox ID="txtInvoiceList" runat="server" Height="145px" Width="500px" Font-Names="Courier New"></asp:ListBox>
        </div>
        <br />
        
        <div id="InvoiceDetail" style="display:none;height:175px;width:500px;" >
        Invoice Item Placeholder div tag (fixed height).
        </div>

</td></tr></table>
</center>
        <br />
        <hr />
        <div style="margin-left:20px;margin-right:25px">
        This sample demonstrates how to handle multiple script callbacks from a single page.
            To check out this demo
            run the form and select a new customer to switch the list of invoices for that customer
            in the list. Then, selecting an invoice displays the lineitems for that invoice as
            an Html table below the invoice list.<br />
            <br />
            This sample shows two different modes of returning data from the server: The first
            list is returned as a delimited list and rendered on the client via script, while
            the second list is returned as Html generated on the server and simply embedded
            into the form.
            <br />
            Both approaches have their advantages and disadvantage. The List example works well because 
            it updates the list control only, while the Html list makes the page jump as the list size 
            varies between invoices. But hte List also doesn't look nice (because you can't have multiple
            list columns) and is a lot more work to fill dynamically rather than filling a placeholder
            on the form. 
            </div>
        <hr />
        <ww:Showcode ID="btnShowCode" runat="Server" CodeFile="~/ScriptCallbacks/InvoiceLookup.aspx.cs"></ww:Showcode>    
        <ww:Showcode ID="btnShowASPX" runat="Server" CodeFile="~/ScriptCallbacks/InvoiceLookup.aspx" Text="Show ASPX"></ww:Showcode>    
    </div>
<script>
</script>
    </form>
        
</body>
</html>
