﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="SimpleCallBack.aspx.cs" Inherits="SimpleCallBack" enableviewstate=false Trace="false" EnableEventValidation="false" %>
<%@ Register Tagprefix="ww" tagname="ShowCode" Src="~/ShowCode.ascx" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Simple Script Callback</title>
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
</head>
<body style="margin-top:0px;margin-left:0px">
<script type="text/javascript">
function OnCallback(Result,Context) 
{
    alert( Result );    
}
</script>        

<div>
    <h1>Simple Client Callback</h1>
    <form id="form1" runat="server">
    <div style="margin-left:20px;margin-right:10px">
        <a href="../default.aspx">Home</a><br />
        <br />
        <input type="button" runat="server" value="Get Server Time" 
               ID="btnCallServer" onclick='<%= this.ScriptRef %>'/><br />
        <hr />
        <span id="lblMessage" class="errormessage"></span>        
        <small>Page loaded on: <%= DateTime.Now %></small>
        <blockquote>
        This very simple page demonstrates the very basic implementation of a CallBack EventHandler.
        When you click the button above, client script goes out and calls the
        server. The server responds by returning the Server Time and returning and the event id (in
        this case a static string 'TimeCallBack') passed to the server. Notice that although we're
        calling the server, the HTML page itself does not refresh (the time value stays the same).
        <p />    
            
        While a simplistic demo it tries to demonstrates how data travels between client and server and 
        shows the minimal implementation code which merely requires a few lines of code on the server.
        <p />
            You can view the code below. All code, including client script is generated on the
            server in the code behind page. The ASPX page doesn't contain any script or logic in this simple scenario.
            In more complex callbacks, though, you'd see at least see
            the callback script code
            in the ASPX page.</blockquote>
        <hr />
        <ww:Showcode ID="btnShowCode" runat="Server" CodeFile="~/ScriptCallbacks/SimpleCallback.aspx.cs"></ww:Showcode>    
        <ww:Showcode ID="btnShowASPX" runat="Server" CodeFile="~/ScriptCallbacks/SimpleCallback.aspx" Text="Show ASPX"></ww:Showcode>    
    </div>
    </form>
</div>
</body>
</html>
