using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ScriptCallbacks.BusinessObjects;
using Westwind.Web.Controls;

public partial class SimpleCallBack : System.Web.UI.Page, 
                                      ICallbackEventHandler
{
    protected string ScriptRef;

    protected void Page_Load(object sender, EventArgs e)
    {
        // *** Page_Load fires - you can check for callbacks
        // *** with the Page.IsCallback property
        //if (!this.IsCallback)
            this.SetCallBackString();
    }

    protected void SetCallBackString()
    {
        // *** Attach the callback handler to the server event
        // *** via Client Event
       ScriptRef = this.ClientScript.GetCallbackEventReference(
                    this,
                    "document.forms[0].btnCallServer.value",
                    "OnCallback",
                    "this",
                    "OnCallback",
                    true);
       this.btnCallServer.Attributes.Add("onclick", ScriptRef);
    }

    // *** Capture the event argument in this field
    string eventArgument = "";

    // *** Initiate the callback by capturing the event argument
    void ICallbackEventHandler.RaiseCallbackEvent(string eventArgument)
    {
        this.eventArgument = eventArgument;
    }

    // *** Generate the callback result as a string
    string ICallbackEventHandler.GetCallbackResult()
    {
        return "Hello from the Server. Time is: " + DateTime.Now.ToString() + 
               "\r\nPassed event argument: " + this.eventArgument;
    }

}
