﻿Sys.UI.ToolTip = function(associatedElement) {
    Sys.UI.ToolTip.initializeBase(this, [associatedElement]);
    
    this.element = associatedElement ; 

    var _controlId = this.element.id;
        
    var _message = "";
    this.set_message = function(message) {
        _message = message;
    }

    var _timeout = 3000;
    this.set_timeout = function(timeout) {
        _timeout = timeout;
    }  
    
    var _position = "BottomLeft"; 
    this.set_position = function(position) {
        _position = position;   
    }  
    
    var _timer = new Sys.Timer(); 
    _timer.controlId = this.element.id;
    
    var _hideToolTipHandler = null;
    
    this.show = function() {
        this._showToolTip(_message,_timeout,_position);
    }
    
    this.hide = function() {
        this._hideToolTip();}

   
    this.getDescriptor = function() {
        var td = Sys.UI.ToolTip.callBaseMethod(this, 'getDescriptor');
        td.addProperty('message', String);
        td.addProperty('timeout', Number);
        td.addProperty('position', String);
        return td;
    }
    
    this.initialize = function() {
        Sys.UI.ToolTip.callBaseMethod(this, 'initialize');
        _hideToolTipHandler = Function.createDelegate(this, this._hideToolTip);
    }
    
    this.dispose = function() {
        Sys.UI.ToolTip.callBaseMethod(this, 'dispose');
    }
    

    this._showToolTip = function (Message,Timeout,Position) 
    {
        var ControlId = this.element.id;
        
        var Ctl = $(ControlId);
        if (Ctl == null)
            return;
        
        var ToolTip = $(ControlId + "_ToolTip")
        var Shadow = $(ControlId + "_ToolTipShadow")
        var Added = false;
        if ( Shadow == null)
            Shadow = document.createElement('div');
        if ( ToolTip == null)
        {
           ToolTip = document.createElement('div');
           Ctl.parentNode.appendChild(Shadow);
           Ctl.parentNode.appendChild(ToolTip);
        }
        if ( Position == null)
            Position = "BottomLeft";
            
        var Style=ToolTip.style;    
        var Style2=Shadow.style;    
        Style.display = '';
        Style2.display = '';
        Style.width='';
        Style.height='';
        
        ToolTip.id = ControlId + "_ToolTip";
        Style.background = "cornsilk";
        Style.color = "black";
        Style.borderWidth="1px";
        Style.borderStyle="solid";
        Style.borderColor="gray";
        Style.padding="2";
        Style.fontSize = "8pt";
        Style.fontWeight = "normal";

        var OldPosition=Ctl.style.position;
        
        Ctl.style.position = "absolute";
        ToolTip.innerHTML = Message;
        Style.position = "absolute";

        var Left = Ctl.offsetLeft + 10;
        var Top = Ctl.offsetTop + Ctl.offsetHeight - 5;
        if( Position == "BottomRight")
        {
            Left = Ctl.offsetLeft + Ctl.offsetWidth - 10;
            Top = Ctl.offsetTop + Ctl.offsetHeight - 5;
        }
        else if (Position == "TopLeft")
        {
            Left = Ctl.offsetLeft + 2;
            Top = Ctl.offsetTop + 2;
        }
        else if( Position == "Mouse")
        {
            if (window.event) 
            {
                Left = window.event.clientX;
                Top = window.event.clientY;
            }
        }
        var Width = ToolTip.offsetWidth + 2;  // Message.length * 6.5;
        if (Width > 400)
            Width=400;
        
        Style.left = Left + "px";
        Style.top = Top + "px";
        Style.width= Width + "px";
       
        Shadow.id = ControlId + "_ToolTipShadow";
        Style2.position = "absolute";
        Style2.background = "silver";
        Style2.left = Left + 2 + "px";
        Style2.top = Top + 2 + "px";
        Style2.width = ToolTip.offsetWidth + "px";
        Style2.height = ToolTip.offsetHeight + "px";
        
        Ctl.style.position = OldPosition;    
        
        if (Timeout && Timeout > 0)
        {
            window.setTimeout(this._hideToolTip,Timeout);
        }
           //window.setTimeout(this._hideToolTip,Timeout);
    }
    this._hideToolTip = function ()
    {
        var ControlId = _controlId;
        var Ctl = $(ControlId +  "_ToolTip");
        if (Ctl == null)
            return;
        Ctl.style.display="none";
        Ctl = $(ControlId +  "_ToolTipShadow").style.display="none";
    }
}
Type.registerSealedClass('Sys.UI.ToolTip', Sys.UI.Control);
Sys.TypeDescriptor.addType('script','tooltip', Sys.UI.ToolTip);