<%@ Page Language="C#" AutoEventWireup="true" CodeFile="ComplexObjects.aspx.cs" Inherits="ComplexObjects"
    EnableViewState="false" EnableEventValidation="false" %>

<%@ Register Namespace="Westwind.Web.Controls" Assembly="wwWebControls" TagPrefix="ww" %>
<%@ Register Src="~/ShowCode.ascx" TagName="ShowCode" TagPrefix="uc1" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>wwHoverWindow Method Callbacks</title>
    <link href="../WestWind.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="form1" runat="server">

<script type="text/javascript">
    var Customer = null;
    
    function GetCustomerEntity_Callback(Result)
    {
        if (Result == null)
        {
            alert("Callback Error.");
            return;
        }
        if(Result.IsCallbackError)
        {
            alert("Error: " + Result.Message);
            return;
        }
        
        // *** Update global Customer reference
        Customer = Result;    

        // *** Longhand
        document.getElementById('txtCompanyName').value = Customer.Companyname;
        
        // *** ShortCut $ function is equivalent to document.getElementById
        $('txtContactName').value = Customer.Contactname;
        $('txtAddress').value = Customer.Address;
        
        // *** Child object value
        $('txtPhone').value = Customer.PhoneNumbers.HomePhone;
        
        var Panel = document.getElementById('OrderDetailPane');
        if ( !document.getElementById('chkReturnOrderEntities').checked )
        {
            Panel.style.display='none';            
            return;
        }

        Panel.style.display='';
        var List = document.getElementById('lstOrders');
            
        for (var x=List.options.length-1; x > -1; x--) 
        {
            List.remove(0);
        }
        
        for (x=0; x < Customer.Orders.length; x++ )
        {
            var Order = Customer.Orders[x]; 
            
            var option = document.createElement("option");
		    option.text = Order.Orderid.toString() + ' - ' + Order.Orderdate.toLocaleDateString();
		    
		    if ( window.navigator.appName.toLowerCase().indexOf("microsoft") > -1) 
		        List.add(option);  
		    else
		        List.add(option, null); 
         }
    }    

    // Pass the Customer Object loaded on the page back to
    // the server.
    function ReturnObject()
    {
        // *** Take the object with it's updated data
        // *** and send it to the server.
        if (Customer) 
        {   

            Customer.Companyname = document.getElementById('txtCompanyName').value;
            Customer.Contactname = document.getElementById('txtContactName').value;
            Customer.Address = document.getElementById('txtAddress').value;
            Customer.PhoneNumbers.HomePhone = document.getElementById('txtPhone').value;
            
            LookupPanel.ReturnCustomerEntity(Customer,ReturnObject_Callback);
        }
        else
            alert('Customer Object doesn\'t exist');
    }

    function ReturnObject_Callback(Result)
    {
        alert(Result);
    }

    function GetCustomerList_Callback(Result)
    {
        HideToolTip('lstCustomerList');
        
        if (Result == null) 
        {
            alert("Invalid Server Response");
            return;
        }
        if (Result.IsCallbackError)
        {
            alert(Result.Message);
            return;
        }
        
        var List = $('lstCustomerList');
        var Table = Result;

        // *** Clear the list first
        for (x=List.options.length-1; x > -1; x--) 
        {
            List.remove(0);
        }

        // *** Now loop through rows and assign to list            
        for (x=0; x < Table.Rows.length; x++ )
        {
            var Row = Table.Rows[x];  // Mozilla needs to assign
            
            var option = document.createElement("option");
		    option.text = Row.CompanyName;
		    option.value = Row.CustomerId;

		    if ( window.navigator.appName.toLowerCase().indexOf("microsoft") > -1) 
		        List.add(option);  
		    else
		        List.add(option, null); 
         }
        
         SelectedIndex = 0;
    }
        </script>

        <h1>
            wwHoverWindow Complex Method Callbacks</h1>
        <br />
        <a href="../default.aspx"><span style="color: #00008b">Home</span></a> | <a href="ComplexObjects.aspx">
            Reset Page</a><span style="font-style: italic; font-size: x-small"> |&nbsp; Page generated
                at:
                <%= DateTime.Now %>
            </span>
        <div style="margin-left: 15px">
            <p />
            The following examples call methods on the server from the client, returning typed
            result values that are displayed on the client without PostBacks. The text beside
            the header shows the server side method signature called. To see what's happening
            I recommend you hook up an HTTP viewer like <a href="http://www.fiddlertool.com/">Fiddler</a>
            to watch the HTTP traffic.<br />
            <br />
            <br />
            <strong>Returning a DataTable from the server<br />
            </strong><span style="font-size: 8pt">protected DataTable GetCustomerList()</span><br />
            <hr />
            
            <!-- DataTable GetCustomerList DropDown Sample -->
            <asp:DropDownList ID="lstCustomerList" runat="server" Width="350px" 
                onchange="$('txtCustomerId').value = this.value">
            </asp:DropDownList>
            <input id="btnGetCustomerList" type="button" value="Load" 
                   onclick="ShowToolTip('lstCustomerList','Updating...',0); LookupPanel.GetCustomerList(GetCustomerList_Callback);"
                style="width: 85px" />
            <input type="button" id="btnClearCustomerList" value="Clear" onclick="var List = document.getElementById('lstCustomerList');for (var x=List.options.length-1; x > -1; x--) {List.remove(0);}"
                style="width: 85px" />
            <br />
            <br />
            
            <!-- Returning an object from the server to the client -->
            <strong>Returning an Object from the server<br />
            </strong><span style="font-size: 8pt">protected customersEntity GetCustomerEntity(string
                CustomerId) &nbsp; (customersEntity is an object)</span><br />
            <hr />
<asp:TextBox ID="txtCustomerId" runat="server" Width="126px">ALFKI</asp:TextBox>
<input id="Button1" type="button" value="Return Customer Object" onclick="LookupPanel.GetCustomerEntity(document.getElementById('txtCustomerId').value,GetCustomerEntity_Callback);"
    style="width: 221px" />
            <br />
            <asp:CheckBox ID="chkReturnOrderEntities" runat="server" Text="Return Order Entities" /><br />
            <br />
            <table>
                <tr>
                    <td valign="top">
                        Name:<br />
                        <asp:TextBox ID="txtContactName" runat="server" Width="350px"></asp:TextBox><br />
                        Company:<br />
                        <asp:TextBox ID="txtCompanyName" runat="server" Width="350px"></asp:TextBox><br />
                        Address:<br />
                        <asp:TextBox ID="txtAddress" runat="server" Width="350px" Height="66px" TextMode="MultiLine"></asp:TextBox><br />
                        Phone:<br />
                        <asp:TextBox ID="txtPhone" runat="server" Width="350px"></asp:TextBox></td>
                    <td valign="top">
                        <!-- Order Display Pane - hidden until you return order child objects -->
                        <div id="OrderDetailPane" style="margin-left: 40px; display: none">
                            Customer's Orders:<br />
                            <asp:ListBox ID="lstOrders" runat="server" Height="155px" Width="400px"></asp:ListBox>
                        </div>
                    </td>
                </tr>
            </table>
            <br />
            
            
            <!-- Pass back a complex object to the server demo -->
            <strong>Passing the object &nbsp;back to the server<br />
            </strong><span style="font-size: 8pt">protected string ReturnCustomerEntity(CustomerEntity
                Customer)</span><br />
            <input type="button" name="btnReturnObject" value="Update Customer Object" 
                   onclick="ReturnObject();"
                style="width: 208px" />
            <br />
            <hr />
            <br />
            Posting back to the server also still works as usual - although you will see nothing
            much<br />
            happen here other than the Postback flash.<br />
            <asp:Button ID="btnServerPost" runat="server" Text="Server POST" /><br />
            <blockquote>
                <hr />
                This sample demonstrates using the wwHoverPanel class to call methods of the
                current page and pass objects from<br />
                the server to the client and then back using the JSON encoding format.<br />
                <br />
                The first sample returns a DataTable which can be accessed in client code. So you
                can use&nbsp;<br />
                <em>CustomerList.Rows[0].Customerid </em>to access individual rows and fields. DataTables
                and DataRows can be returned<br />
                currently but not passed back to the server.

                The
                second example returns a complex object from the server. The object contains a child object (PhoneNumbers)<br />
                and an array of Order objects which are returned only if the Return Order Entries
                checkbox is checked. The object<br />
                is passed from the server to the client where the values are displayed in the textboxes.
                You can change values<br />
                and then Update the object, which sends the updated values that are stored back
                into the object to the server.<br />
                The client side object is JSON encoded and sent back to the server. The server then
                merely echos the values<br />
                back as a string. If you changed the values in the fields you should see those values
                returned from the server.
            <hr />
            <uc1:ShowCode ID="ShowSource" runat="server" CodeFile="~/wwHoverPanel/ComplexObjects.aspx.cs">
            </uc1:ShowCode>
            <uc1:ShowCode ID="ShowAspx" runat="server" CodeFile="~/wwHoverPanel/ComplexObjects.aspx"
                Text="Show ASPX"></uc1:ShowCode>
            </blockquote>
            
            <ww:wwHoverPanel ID="LookupPanel" runat="server" NavigateDelay="1" PostBackMode="POST"
                ServerUrl="" Style="display: none; background: white; width: 450px" AdjustWindowPosition="False"
                ClientEventHandler="CallServer_Callback" EventHandlerMode="CallPageMethod" PostBackFormName="form1"
                ScriptLocationType="WebResource">
            </ww:wwHoverPanel>
    </form>
</body>
</html>
