<%@ Page Language="C#" AutoEventWireup="true" CodeFile="PageCallback.aspx.cs" Inherits="PageCallback" %>
<%@Register Namespace="Westwind.Web.Controls" assembly="wwWebControls" TagPrefix="ww" %>
<%@ Register Src="~/ShowCode.ascx" TagName="ShowCode" TagPrefix="uc1" %>
<html>
<head id="Head1" runat="server">
    <title>wwHoverWindow Method Callbacks</title>
    <link href="..\WestWind.css" rel="stylesheet" type="text/css" />
</head>
<body onload="document.getElementById('lstInvoices').onchange();">
    <form runat="Server" id="form1" method="post">
    <script type="text/javascript">
    function InvoiceDetail_Callback(Result)
    {
        var Panel = document.getElementById('InvoiceDetailPanel');    
        Panel.innerHTML = Result;
        ShowPanel('InvoiceDetailPanel'); // make it visible
    }
    </script>
    <div>
        <h1> wwHoverPanel Page Callbacks</h1>
        <br />
        <a href="../default.aspx"><span style="color: #00008b">Home</span></a> | <a href="PageCallback.aspx">
            Reset Page</a><p>
        </p>
        <div style="margin-left: 15px">
        <span style="font-style:italic;font-size:x-small">Page generated at: <%= DateTime.Now %></span>
        <p></p>
            This sample demonstrates Page Callback functionality which allows you to specify
            an external URL<br />
            and a callback function on the
            page. The URL
            returns a response which is then immediately
            sent<br />
            to the callback routine. This is extremely useful for callbacks that return HTML
            pages or fragments<br />
            which can be integrated with just a couple of lines of code. It also allows moving
            remote functionality<br />
            out of the current page context which may be desirable.<br />
            <br />
            
            <b>Select an invoice:</b> <br />
            <asp:DropDownList ID="lstInvoices" runat="server" Width="400px"  
                              onchange="StartCallback('InvoiceDetailPanel',event,'id=' + $('lstInvoices').value );">
            </asp:DropDownList>
            <hr />
            
             <ww:wwhoverpanel id="InvoiceDetailPanel" runat="server" navigatedelay="1"
                          ServerUrl="InvoiceAbstract.aspx" 
                          ClientEventHandler="InvoiceDetail_Callback" 
                          EventHandlerMode="CallExternalPage" 
                          Height="350px" Width="550px" ScriptLocationType="WebResource"  >
             </ww:wwhoverpanel>
            <br />
            <br />
        <hr />
        </div>
        
        
        <blockquote>
            This sample demonstrates to easily display Html content from another (or the same)
            Url
            and display it locally. The concept of this mechanism is to specify a URL, initiate
            the
            callback and then simply receiving a string parameter. In this example the wwHoverPanel
            control itself is used to display the retrieved HTML content.</blockquote>
        <blockquote>
            The client code here is hooked to the <em>onchange</em> even of the drop down and
            it fires:<br />
            <br />
            <span style="font-family: Courier New">StartCallback('InvoiceDetailPanel',event,</span><span
                style="font-family: Courier New">'id='
                + document.getElementById('lstInvoices').value );"</span><br />
            <br />
            The callback method is defined on the control and it handles the callback which
            is called with the string result from the accessed URL.</blockquote>
        <blockquote>
        
            <hr />
            <uc1:showcode id="ShowSource" runat="server" codefile="~/wwHoverPanel/PageCallback.aspx.cs"></uc1:showcode>
            <uc1:showcode id="ShowAspx" runat="server" codefile="~/wwHoverPanel/PageCallback.aspx"
                text="Show ASPX"></uc1:showcode>
            &nbsp; &nbsp;
        </blockquote>
        
    </div>
    </form>
</body>
</html>
