<%@ Page Language="C#" AutoEventWireup="true" CodeFile="SimpleMethodCallbacks.aspx.cs"
    Inherits="SimpleMethodCallbacks" EnableViewState="false" EnableEventValidation="false" %>
<%@ Register Namespace="Westwind.Web.Controls" Assembly="wwWebControls" TagPrefix="ww" %>
<%@ Register Src="~/ShowCode.ascx" TagName="ShowCode" TagPrefix="uc1" %>
<html>
<head runat="server">
    <title>wwHoverWindow Method Callbacks</title>
    <link href="~/WestWind.css" rel="stylesheet" type="text/css" />
</head>
<body>
       <form id="form1" runat="server">

<script type="text/javascript">
    var LookupPanel_Context = null;
    function Test() 
    {
        LookupPanel_Context = new RequestContext(LookupPanel_Url,LookupPanel_Callback);
        GetServerUrl(LookupPanel_Context);
    }
    var CustomerObject = null;
    
    function Helloworld_Callback(Result)
    {
        if (Result == null)
        {
            alert("Invalid result returned.");
            return;
        }
        if (Result.IsCallbackError)
        {
            alert(Result.Message);
            return;
        }
        
        alert(Result);
    }

    
    function AddNumbers_Callback(Result)
    {
        if (Result == null)
        {
            alert('Callback Error.');
            return;
        }
        if (Result.IsCallbackError)
        {
            alert(Result.Message);
            return;
        }
        Result = Result;
        document.getElementById('txtAddResult').value = Result;
    }    
    
    function ThrowException_Callback(Result)
    {
        if (Result.IsCallbackError)
        {
            alert("An error occurred on the server:\r\n\r\n" + Result.Message);
            return;
        }
        
        // *** Otherwise we have our result value - in this case a string
        alert(Result);
    }
        </script>

        <div>
            <h1>
                wwHoverWindow Method Callbacks</h1>
            <br />
            <a href="../default.aspx">Home</a> | <a href="SimpleMethodCallbacks.aspx">
                Reset Page</a> | <span style="font-style: italic; font-size: x-small">Page generated
                    at:
                    <%= DateTime.Now %></span>
                    
                    <div style="margin-left: 15px">
                        <p />
                The following examples call methods on the server from the client, returning
            typed result values that are displayed on the client without PostBacks. The text
            beside the header shows the server side method signature called. To see what's happening
            I recommend you hook up an HTTP viewer like <a href="http://www.fiddlertool.com/">Fiddler</a>
            to watch the HTTP traffic.<br />
            <br />
            <br />
            <strong>Mandatory Hello World Method<br />
            </strong><span style="font-size: 8pt">protected string Helloworld(string Name)</span><br />
            <hr />
            &nbsp;<strong></strong>Enter your name:
            <asp:TextBox ID="txtName" runat="server" Width="178px">John Doe</asp:TextBox>
            <input id="btnSubmit" type="button" value="Say Hello" 
            onclick="LookupPanel.HelloWorld(document.getElementById('txtName').value,Helloworld_Callback);" /><br />
            <br />
            <br />
            <!-- Number Calculator Sample -->
            <strong>Number Addition<br />
            </strong><span style="font-size: 8pt">protected decimal AddNumbers(decimal Num1,decimal
                Num2) &nbsp; (try entering an invalid number)</span><strong><br />
                </strong>
            <hr />
            <asp:TextBox ID="txtAdd1" runat="server" Width="44px" Style="text-align: right;">12</asp:TextBox>
            +
            <asp:TextBox ID="txtAdd2" runat="server" Width="48px" Style="text-align: right;">11</asp:TextBox>
            <br />
            <input id="btnMethod" type="button" value="Add Numbers" onclick="AddNumbers();" style="width: 123px" />

            <script type="text/javascript">
        function AddNumbers()
        {
            var Num1=document.getElementById('txtAdd1').value-0; // force to number
            var Num2=document.getElementById('txtAdd2').value-0;
            
            // *** Note that you have to pass the value as a number!
            // *** Server Signature: decimal AddNumbers(decimal,decimal)
            LookupPanel.AddNumbers(Num1,Num2,AddNumbers_Callback);
        }
            </script>

            <br />
            =
            <asp:TextBox ID="txtAddResult" runat="server" Width="102px" Style="text-align: right;"></asp:TextBox><br />
            <br />
            <br />
            <strong>Server Exception Marshalling<br />
            </strong><span style="font-size: 8pt">protected string ThrowException(string Value)
                &nbsp; &nbsp; (checked checkbox causes a server Exception)</span><br />
            <hr />
            <br />
            <asp:TextBox runat="server" ID="txtSaySomething" textmode=MultiLine width="400" Height="50"></asp:TextBox>
            <br />
            <input id="btnSaySomething" type="button" value="Say Something" 
                    onclick="LookupPanel.ThrowException(document.getElementById('txtSaySomething').value,ThrowException_Callback);"
                style="width: 123px" /><asp:CheckBox ID="chkException" runat="server" Text="Throw Exception" /><br />
            <br />
            <hr />
            &nbsp;This sample demonstrates using the wwHoverPanel class to call methods on the
            current page. To call the method on the server:<br />
            <br />
            1. Create a method on the server with standard parameters<br />
            2. Mark up the method with the [CallbackMethod] attribute<br />
            3. Hook up your clientside code with code like this:<br />
            &nbsp;&nbsp; <span style="font-size: 10pt; font-family: Monospace">CallMethod('LookupPanel','Helloworld',document.getElementById('txtName').value,PassObject_Callback);<br />
            </span><em><span style="font-size: 8pt">&nbsp; &nbsp; (Parameters: ControlId,Method
                name,Parameter1,Parameter2...n,CallbackMethod)</span></em><br />
            4. Implement the callback method which receives a result value or object.<br />
            <br />
            Values are passed back from the server as typed values using JSON, so you can pass
            back strings, dates, number,<br />
            bools as well as many objects, including Arrays, IList based objects, &nbsp;DataTables
            and DataRows. You can also pass<br />
            typed values and objects back to the server. Currently simple types, simple hierarchical
            objects and array and IList<br />
            style collections are supported. DataTable/DataRow are not support for return trips
            at this point.<br />
            <br />
            Finally this example also demonstrates how an exception is returned from the server.
            Check the Throw Exception<br />
            checkbox, then click on the Pass Entity button. When checked the server code throws
            an explicit exception which<br />
            is returned as a special Exception object you can check for. Typically your client
            script callback handler checks<br />
            for a null result and can check for Result.IsCallbackError to see if an error occured
            on the server. Result.Message<br />
            returns the error message.</div>
        <hr />
        <uc1:ShowCode ID="ShowSource" runat="server" CodeFile="~/SimpleMethodCallbacks.aspx.cs">
        </uc1:ShowCode>
        <uc1:ShowCode ID="ShowAspx" runat="server" CodeFile="~/SimpleMethodCallbacks.aspx"
            Text="Show ASPX"></uc1:ShowCode>
        &nbsp;
<ww:wwHoverPanel ID="LookupPanel" runat="server" NavigateDelay="1" PostBackMode="POST"
    ServerUrl="" Style="display: none; background: white; width: 450px" AdjustWindowPosition="False"
    ClientEventHandler="CallServer_Callback" EventHandlerMode="CallPageMethod" PostBackFormName="form1"
    ScriptLocationType="EmbeddedInPage">
</ww:wwHoverPanel>
</div>
    </form>
</body>
</html>
